'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _flattenChildren = require('./flattenChildren');

var _flattenChildren2 = _interopRequireDefault(_flattenChildren);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Children = {
  map: function map(children, fn, ctx) {
    if (children == null) return null;
    children = Children.toArray(children);
    return children.map(function (child, index) {
      return fn.call(ctx, child, index);
    });
  },
  forEach: function forEach(children, fn, ctx) {
    if (children == null) return null;
    children = Children.toArray(children);
    children.forEach(function (child, index) {
      return fn.call(ctx, child, index);
    });
  },
  count: function count(children) {
    return Children.toArray(children).length;
  },
  only: function only(children) {
    children = Children.toArray(children);
    if (children.length !== 1) throw new Error('Children.only expected to receive a single React element child.');
    return children[0];
  },
  toArray: function toArray(children) {
    if (children == null) return [];
    // flatten children
    children = (0, _flattenChildren2.default)(children);
    return Array.isArray(children) ? children : [].concat(children);
  }
};

exports.default = Children;
module.exports = exports['default'];