'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _inject = require('../inject');

var _inject2 = _interopRequireDefault(_inject);

var _instance = require('../vdom/instance');

var _instance2 = _interopRequireDefault(_instance);

var _driverServer = require('driver-server');

var _driverServer2 = _interopRequireDefault(_driverServer);

var _serializer = require('../server/serializer');

var _serializer2 = _interopRequireDefault(_serializer);

var _unmountComponentAtNode = require('../unmountComponentAtNode');

var _unmountComponentAtNode2 = _interopRequireDefault(_unmountComponentAtNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Init
(0, _inject2.default)({
  driver: _driverServer2.default
});

exports.default = {
  create: function create(element) {
    var container = _driverServer2.default.createBody();
    var rootComponent = _instance2.default.render(element, container);
    var renderedComponent = rootComponent.getRenderedComponent();

    renderedComponent.toJSON = function () {
      return new _serializer2.default(container).toJSON();
    };

    renderedComponent.getInstance = function () {
      return renderedComponent._instance;
    };

    renderedComponent.update = function (element) {
      _instance2.default.render(element, container);
    };

    renderedComponent.unmount = function () {
      (0, _unmountComponentAtNode2.default)(container);
    };

    return renderedComponent;
  }
};
module.exports = exports['default'];